searchNodes=[{"doc":"Tensorflow lite intepreter for Elixir. Deep Learning inference framework for embedded devices.","ref":"TflInterp.html","title":"TflInterp","type":"module"},{"doc":"Adjust NMS result to aspect of the input image. (letterbox) Parameters: nms_result - NMS result {:ok, result} [rx, ry] - aspect ratio of the input image","ref":"TflInterp.html#adjust2letterbox/2","title":"TflInterp.adjust2letterbox/2","type":"function"},{"doc":"Get name of backend NN framework.","ref":"TflInterp.html#framework/0","title":"TflInterp.framework/0","type":"function"},{"doc":"Ensure that the back-end framework is as expected.","ref":"TflInterp.html#framework?/1","title":"TflInterp.framework?/1","type":"function"},{"doc":"Get the flat binary from the output tensor on the interpreter. Parameters mod - modules' names or session. index - index of output tensor in the model","ref":"TflInterp.html#get_output_tensor/3","title":"TflInterp.get_output_tensor/3","type":"function"},{"doc":"Get the propaty of the tflite model. Parameters mod - modules' names","ref":"TflInterp.html#info/1","title":"TflInterp.info/1","type":"function"},{"doc":"Invoke prediction. Two modes are toggled depending on the type of input data. One is the stateful mode, in which input/output data are stored as model states. The other mode is stateless, where input/output data is stored in a session structure assigned to the application. Parameters mod/session - modules name(stateful) or session structure(stateless). Examples. output_bin = session ( ) # stateless mode |&gt; TflInterp . set_input_tensor ( 0 , input_bin ) |&gt; TflInterp . invoke ( ) |&gt; TflInterp . get_output_tensor ( 0 )","ref":"TflInterp.html#invoke/1","title":"TflInterp.invoke/1","type":"function"},{"doc":"Execute post processing: nms. Parameters mod - modules' names num_boxes - number of candidate boxes num_class - number of category class boxes - binaries, serialized boxes tensor[ num_boxes ][4]; dtype: float32 scores - binaries, serialized score tensor[ num_boxes ][ num_class ]; dtype: float32 opts iou_threshold: - IOU threshold score_threshold: - score cutoff threshold sigma: - soft IOU parameter boxrepr: - type of box representation :center - center pos and width/height :topleft - top-left pos and width/height :corner - top-left and bottom-right corner pos","ref":"TflInterp.html#non_max_suppression_multi_class/5","title":"TflInterp.non_max_suppression_multi_class/5","type":"function"},{"doc":"","ref":"TflInterp.html#run/1","title":"TflInterp.run/1","type":"function"},{"doc":"Put a flat binary to the input tensor on the interpreter. Parameters mod - modules' names or session. index - index of input tensor in the model bin - input data - flat binary, cf. serialized tensor opts - data conversion","ref":"TflInterp.html#set_input_tensor/4","title":"TflInterp.set_input_tensor/4","type":"function"},{"doc":"Stop the tflite interpreter. Parameters mod - modules' names","ref":"TflInterp.html#stop/1","title":"TflInterp.stop/1","type":"function"},{"doc":"Ensure that the model matches the back-end framework. Parameters model - path of model file url - download site","ref":"TflInterp.html#validate_model/2","title":"TflInterp.validate_model/2","type":"function"},{"doc":"","ref":"TflInterp.URL.html","title":"TflInterp.URL","type":"module"},{"doc":"Download and process data from url. Parameters url - download site url func - function to process downloaded data","ref":"TflInterp.URL.html#download/2","title":"TflInterp.URL.download/2","type":"function"},{"doc":"Download and save the file from url. Parameters url - download site url path - distination path of downloaded file name - name for the downloaded file","ref":"TflInterp.URL.html#download/3","title":"TflInterp.URL.download/3","type":"function"},{"doc":"Tensorflow lite interpreter for Elixir. Deep Learning inference framework for embedded devices.","ref":"readme.html","title":"TflInterp","type":"extras"},{"doc":"TflInterp is designed based on the following policy. Provide only the Deep Learning inference. It aims to the poor-resource devices such as IOT and mobile. Easy to understand. The inference part, excluding pre/post-processing, can be written in a few lines. Use trained models from major Deep Learning frameworks that are easy to obtain. Multiple inference models can be used from a single application. There are few dependent modules. It does not have image processing or matrix calculation functions. TflInterp does not block the erlang/elixir process scheduler. It runs as an OS process outside of elixir. The back-end inference engine can be easily replaced. It's easy to keep up with the latest Deep Learninig technology. And I'm trying to make TflInterp easy to install. short or concise history The development of Tflinterp started in 2020 Nov. The original idea was to use Nerves to create an AI remote controlled car. In the first version, I implemented Yolo3, but the design strongly depended on the model, which made it difficult to use in other applications. Reflecting on that mistake, I redesigned Tflinterp according to the above design guidelines.","ref":"readme.html#design-policy-features","title":"TflInterp - Design policy (Features)","type":"extras"},{"doc":"It has been confirmed to work in the following OS environment. Windows MSYS2/MinGW64 WSL2/Ubuntu 20.04 Nerves ARMv6, ARMv7NEON and AArch64","ref":"readme.html#platform","title":"TflInterp - Platform","type":"extras"},{"doc":"cmake 3.18.6 or later git","ref":"readme.html#requirements","title":"TflInterp - Requirements","type":"extras"},{"doc":"Since 0.1.3, the installation method of this module has changed. You may need to remove previously installed TflInterp before installing new version. There are two installation methods. You can choose either one according to your purpose. Like any other elixir module, add TflInterp to the dependency list in the mix.exs. def deps do [ ... { :tfl_interp , github : &quot;shoz-f/tfl_interp&quot; , branch : &quot;nerves&quot; } ] end Download TflInterp to a directory in advance, and add that path to the dependency list in mix.exs. # download TflInterp in advance. $ cd / home / { your home } / workdir $ git clone - b nerves https :// github . com / shoz - f / tfl_interp . git def deps do [ ... { :tfl_interp , path : &quot;/home/{your home}/workdir/tfl_interp&quot; } ] end Then you run the following commands in your application project. For Desktop application: $ mix deps.get $ mix compile For Nerves application: $ export MIX_TARGET=rpi3 # &lt;- specify target device tag $ mix deps.get $ mix firmware It takes a long time to finish the build. Because it will download the required files - Tensorflow sources, ARM toolchain [^1], etc - at the first build time. Method 1 saves the downloaded files under &quot;{your app}/deps/tfl_interp&quot;. On the other hand, method 2 saves them under &quot;/home/{your home}/workdir/tfl_interp&quot;. If you want to reuse the downloaded files in other applications, I recommend Method 2. In either method 1 or 2, the external modules required for Tensorflow lite are stored under &quot;{your app}/_build/{target}/.cmake_build&quot; according to the cmakelists.txt that comes with Tensorflow. [^1] Unfortunately, the ARM toolchain that comes with Nerves can not build Tensorflow lite. We need to get the toolchain recommended by the Tensorflow project. After installation, you will have the directory tree like these: Method 1 work_dir + - your - app + - _build / | + - dev / | + - . cmake_build / -- - CMakeCash . txt and external modules that Tensorflowlite depends on . | | The cmake build outputs are stored here also . | + - lib / | | + - tfl_interp | | + - ebin / | | + - priv | | + - tfl_interp -- - executable : tensorflow interpreter . | : | + - deps / | + tfl_interp | | + - 3 rd_party / -- - Tensorflow sources , etc . | | + - lib / -- - TflInterp module . | | + - src / -- - tfl_interp C ++ sources . | | + - test / | | + - toolchain / -- - ARM toolchains for Nerves . | | + - CMakeLists . txt -- - CMake configuration for for building tfl_interp . | | + - mix . exs | : | + - lib / + - test / + - mix . exs Method 2 work_dir + - your - app | + - _build / | | + - dev / | | + - . cmake_build / -- - CMakeCash . txt and external modules that Tensorflowlite depends on . | | | The cmake build outputs are stored here also . | | + - lib / | | | + - tfl_interp | | | + - ebin / | | | + - priv | | | + - tfl_interp -- - executable : tensorflow interpreter . | | : | | | + - deps / | + - lib / | + - test / | + - mix . exs | + - tfl_interp + - 3 rd_party / -- - Tensorflow sources , etc . + - lib / -- - TflInterp module . + - src / -- - tfl_interp C ++ sources . + - test / + - toolchain / -- - ARM toolchains for Nerves . + - CMakeLists . txt -- - CMake configuration for for building tfl_interp . + - mix . exs","ref":"readme.html#installation","title":"TflInterp - Installation","type":"extras"},{"doc":"You get the trained tflite model and save it in a directory that your application can read. &quot;your-app/priv&quot; may be good choice. $ cp your-trained-model.tflite ./priv Next, you will create a module that interfaces with the deep learning model. The module will need pre-processing and post-processing in addition to inference processing, as in the example following. TflInterp provides inference processing only. You put use TflInterp at the beginning of your module, specify the model path as an optional argument. In the inference section, you will put data input to the model ( TflInterp.set_input_tensor/3 ), inference execution ( TflInterp.invoke/1 ), and inference result retrieval ( TflInterp.get_output_tensor/2 ). defmodule YourApp.YourModel do use TflInterp, model: &quot;priv/your-trained-model.tflite&quot; def predict(data) do # preprocess # to convert the data to be inferred to the input format of the model. input_bin = convert-float32-binaries(data) # inference # typical I/O data for Tensorflow lite models is a serialized 32-bit float tensor. output_bin = __MODULE__ |&gt; TflInterp.set_input_tensor(0, input_bin) |&gt; TflInterp.invoke() |&gt; TflInterp.get_output_tensor(0) # postprocess # add your post-processing here. # you may need to reshape output_bin to tensor at first. tensor = output_bin |&gt; Nx.from_binary({:f, 32}) |&gt; Nx.reshape({size-x, size-y, :auto}) * your-postprocessing * ... end end Let's enjoy ;-)","ref":"readme.html#basic-usage","title":"TflInterp - Basic Usage","type":"extras"},{"doc":"There is MNIST web application in demo_mnist directory. You can do it by following the steps below. $ cd demo_mnist $ mix deps.get $ mix run --no-halt And then, please open your browser with &quot; http://localhost:500&quot; .","ref":"readme.html#demo","title":"TflInterp - Demo","type":"extras"},{"doc":"TflInterp is licensed under the Apache License Version 2.0.","ref":"readme.html#license","title":"TflInterp - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Major Features and Improvements feed back from AxonInterp project. added demo_yolov4. revised documents. added the ability to download model files from the url. added the ability to give hints about I/O tensor of the model.","ref":"changelog.html#release-0-1-9-dec-18-2022","title":"Changelog - Release 0.1.9(Dec 18 2022)","type":"extras"},{"doc":"Breaking Changes (from OnnxInterp 0.1.5) the previous download source of nlohmann-json is gone, so changed to another one. Bug Fixes and Other Changes (from OnnxInterp 0.1.4) added two more ways to specify box in NMS.","ref":"changelog.html#release-0-1-8-aug-15-2022","title":"Changelog - Release 0.1.8(Aug 15 2022)","type":"extras"},{"doc":"* fixed non_max_suppression_multi_class / 7 .","ref":"changelog.html#release-0-1-7-jul-11-2022","title":"Changelog - Release 0.1.7(Jul 11 2022)","type":"extras"},{"doc":"Major Features and Improvements Feedback based on OnnxInterp design. update Tensorflow to 2.9.1.","ref":"changelog.html#release-0-1-6-jun-29-2022","title":"Changelog - Release 0.1.6(Jun 29 2022)","type":"extras"},{"doc":"Major Features and Improvements add session mode. add processing time measurement function. update Tensorflow to 2.8.0.","ref":"changelog.html#release-0-1-5-apl-4-2022","title":"Changelog - Release 0.1.5(Apl 4 2022)","type":"extras"},{"doc":"Bug Fixes and Other Changes adjust word alignment of NMS parameter to ARMs.","ref":"changelog.html#release-0-1-4-feb-6-2022","title":"Changelog - Release 0.1.4(Feb 6 2022)","type":"extras"},{"doc":"Breaking Changes change installation methods. see README.md for detail. Major Features and Improvements move the directory to download Tensorflow to &quot;3rd_party&quot;. supported Nerves ARMv6, ARMv7NEON and AArch64(not yet tested). Bug Fixes and Other Changes corrected CMakeLists scripts for MSYS2/MinGW64. revised demo_mnist to fit cimg_ex 0.1.8.","ref":"changelog.html#release-0-1-3-jan-30-2022","title":"Changelog - Release 0.1.3(Jan 30 2022)","type":"extras"},{"doc":"Breaking Changes Major Features and Improvements remove C++ code that depend on C++20 features: src/tfl_interp.cc. limit dependency of mix_cmake to dev . Bug Fixes and Other Changes","ref":"changelog.html#release-0-1-2-jan-17-2022","title":"Changelog - Release 0.1.2(Jan 17 2022)","type":"extras"},{"doc":"File . cd! ( __DIR__ ) # for windows JP System . shell ( &quot;chcp 65001&quot; ) # CAUTION: TflInerp takes several tens of minutes to download the Tensorflow source code. # In this setup, we are using TflInterp which is downloaded and built first. Mix . install ( [ { :tfl_interp , path : &quot;..&quot; } , { :nx , &quot;~&gt; 0.4.1&quot; } ] )","ref":"mbert_qa.html","title":"mobile Bert Q&A","type":"extras"},{"doc":"&quot;BERT Question and Answer&quot;&lt;br&gt; https://www.tensorflow.org/lite/examples/bert_qa/overview?hl=ja &quot;Google Research/MobileBERT&quot;&lt;br&gt; https://github.com/google-research/google-research/tree/master/mobilebert Thanks a lot!!!","ref":"mbert_qa.html#0-original-work","title":"mobile Bert Q&A - 0.Original work","type":"extras"},{"doc":"","ref":"mbert_qa.html#implementation-for-elixir-using-tflinterp","title":"mobile Bert Q&A - Implementation for Elixir using TflInterp","type":"extras"},{"doc":"defmodule MBertQA.Tokenizer do @moduledoc &quot;&quot;&quot; Mini Tokenizer for Tensorflow lite&#39;s mobileBert example. &quot;&quot;&quot; @dic1 :word2token1 @dic2 :word2token2 @dic3 :token2word @doc &quot;&quot;&quot; Load a vocabulary dictionary. &quot;&quot;&quot; def load_dic ( fname ) do Enum . each ( [ @dic1 , @dic2 , @dic3 ] , fn name -&gt; if :ets . whereis ( name ) != :undefined , do : :ets . delete ( name ) :ets . new ( name , [ :named_table ] ) end ) File . stream! ( fname ) |&gt; Stream . map ( &amp; String . trim_trailing / 1 ) |&gt; Stream . with_index ( ) |&gt; Enum . each ( fn { word , index } -&gt; # init dic for encoding. case word do &lt;&lt; &quot;##&quot; , trailing :: binary &gt;&gt; -&gt; :ets . insert ( @dic2 , { trailing , index } ) _ -&gt; :ets . insert ( @dic1 , { word , index } ) end # init dic for decoding. :ets . insert ( @dic3 , { index , word } ) end ) end @doc &quot;&quot;&quot; Tokenize text. &quot;&quot;&quot; def tokenize ( text , tolower \\\\ true ) do if tolower do String . downcase ( text ) else text end |&gt; text2words ( ) |&gt; words2tokens ( ) end defp text2words ( text ) do text # cleansing |&gt; String . replace ( ~r/([[:cntrl:]]| \\x ff \\x fd)/ , &quot;&quot; ) # separate panc with whitespace |&gt; String . replace ( ~r/([[:punct:]])/ , &quot; \\\\ 1 &quot; ) # split with whitespace |&gt; String . split ( ) end defp words2tokens ( words ) do Enum . reduce ( words , [ ] , fn word , tokens -&gt; case wordpiece1 ( word , len = String . length ( word ) ) do { ^ len , token } -&gt; [ token | tokens ] { 0 , token } -&gt; [ token | tokens ] { n , token } -&gt; len = len - n wordpiece2 ( String . slice ( word , n , len ) , len , [ token | tokens ] ) end end ) |&gt; Enum . reverse ( ) end defp wordpiece1 ( _ , 0 ) , do : { 0 , token ( &quot;[UNK]&quot; ) } defp wordpiece1 ( word , n ) do case lookup_1 ( String . slice ( word , 0 , n ) ) do { _piece , token } -&gt; { n , token } nil -&gt; wordpiece1 ( word , n - 1 ) end end defp wordpiece2 ( _ , 0 , tokens ) , do : [ token ( &quot;[UNK]&quot; ) | tokens ] defp wordpiece2 ( word , n , tokens ) do case lookup_2 ( String . slice ( word , 0 , n ) ) do { _piece , token } -&gt; len = String . length ( word ) - n if len == 0 do [ token | tokens ] else wordpiece2 ( String . slice ( word , n , len ) , len , [ token | tokens ] ) end nil -&gt; wordpiece2 ( word , n - 1 , tokens ) end end defp lookup_1 ( x ) , do : lookup ( @dic1 , x ) defp lookup_2 ( x ) , do : lookup ( @dic2 , x ) defp lookup ( dic , x ) , do : List . first ( :ets . lookup ( dic , x ) ) @doc &quot;&quot;&quot; Get token of `word`. &quot;&quot;&quot; def token ( word ) do try do :ets . lookup_element ( @dic1 , word , 2 ) rescue ArgumentError -&gt; nil end end @doc &quot;&quot;&quot; Decode the token list `tokens`. &quot;&quot;&quot; def decode ( tokens ) do Enum . map ( tokens , fn x -&gt; :ets . lookup_element ( @dic3 , x , 2 ) end ) end end defmodule MBertQA.Feature do @moduledoc &quot;&quot;&quot; Feature converter for Tensorflow lite&#39;s mobileBert example. Feature tensor[4][] is consisted of [0] list of tokens converted from query and contex text in the dictionary. [1] list of token masks. all are 1. [2] segment type indicator. 0 for query, 1 for context. [3] index of the token&#39;s position in the context map. see bellow. Context map is a list of words separated from the context by whitespace. &quot;&quot;&quot; alias MBertQA.Tokenizer @max_seq 384 @max_query 64 defdelegate load_dic ( fname ) , to : Tokenizer , as : :load_dic @doc &quot;&quot;&quot; &quot;&quot;&quot; def convert ( query , context ) do { t_query , room } = convert_query ( query ) { t_context , room , context_map } = convert_context ( context , room ) { Nx . concatenate ( [ cls ( ) , t_query , sep ( 0 ) , t_context , sep ( 1 ) , padding ( room ) ] , axis : 1 ) , context_map } end defp convert_query ( text , room \\\\ @max_seq - 3 ) do t_query = convert_text ( text , @max_query , 0 ) { t_query , room - Nx . axis_size ( t_query , 1 ) } end defp convert_context ( text , room ) do context_map = String . split ( text ) { t_context , room } = context_map |&gt; Stream . with_index ( ) |&gt; Enum . reduce_while ( { [ ] , room } , fn { _ , _ } , { _ , 0 } = res -&gt; { :halt , res } { word , index } , { t_context , max_len } -&gt; t_word = convert_text ( word , max_len , 1 , index ) { :cont , { [ t_word | t_context ] , max_len - Nx . axis_size ( t_word , 1 ) } } end ) { Enum . reverse ( t_context ) |&gt; Nx . concatenate ( axis : 1 ) , room , context_map } end defp convert_text ( text , max_len , segment , index \\\\ - 1 ) do tokens = text |&gt; Tokenizer . tokenize ( ) |&gt; Enum . take ( max_len ) |&gt; Nx . tensor ( ) len = Nx . axis_size ( tokens , 0 ) Nx . stack ( [ tokens , Nx . broadcast ( 1 , { len } ) , Nx . broadcast ( segment , { len } ) , Nx . broadcast ( index , { len } ) ] ) |&gt; Nx . as_type ( { :s , 32 } ) end defp cls ( ) do Nx . tensor ( [ [ Tokenizer . token ( &quot;[CLS]&quot; ) ] , [ 1 ] , [ 0 ] , [ - 1 ] ] , type : { :s , 32 } ) end defp sep ( segment ) do Nx . tensor ( [ [ Tokenizer . token ( &quot;[SEP]&quot; ) ] , [ 1 ] , [ segment ] , [ - 1 ] ] , type : { :s , 32 } ) end defp padding ( n ) do Nx . tensor ( [ 0 , 0 , 0 , - 1 ] , type : { :s , 32 } ) |&gt; Nx . broadcast ( { 4 , n } , axes : [ 0 ] ) end end","ref":"mbert_qa.html#1-defining-companion-modules","title":"mobile Bert Q&A - 1.Defining companion modules","type":"extras"},{"doc":"Pre-processing:&lt;br&gt; Post-processing:&lt;br&gt; defmodule MBertQA do @moduledoc &quot;&quot;&quot; Documentation for `MBertQA`. &quot;&quot;&quot; alias TflInterp , as : NNInterp use NNInterp , model : &quot;./model/lite-model_mobilebert_1_metadata_1.tflite&quot; , url : &quot;https://github.com/shoz-f/tfl_interp/releases/download/0.0.1/lite-model_mobilebert_1_metadata_1.tflite&quot; alias MBertQA.Feature @max_ans 32 @predict_num 5 def setup ( ) do Feature . load_dic ( &quot;./model/vocab.txt&quot; ) end def apply ( query , context , predict_num \\\\ @predict_num ) do # pre-processing { feature , context_map } = Feature . convert ( query , context ) # prediction mod = __MODULE__ |&gt; NNInterp . set_input_tensor ( 0 , Nx . to_binary ( feature [ 0 ] ) ) |&gt; NNInterp . set_input_tensor ( 1 , Nx . to_binary ( feature [ 1 ] ) ) |&gt; NNInterp . set_input_tensor ( 2 , Nx . to_binary ( feature [ 2 ] ) ) |&gt; NNInterp . invoke ( ) [ end_logits , beg_logits ] = Enum . map ( 0 .. 1 , fn x -&gt; NNInterp . get_output_tensor ( mod , x ) |&gt; Nx . from_binary ( { :f , 32 } ) end ) # post-processing [ beg_index , end_index ] = Enum . map ( [ beg_logits , end_logits ] , fn t -&gt; Nx . argsort ( t , direction : :desc ) |&gt; Nx . slice_along_axis ( 0 , predict_num ) |&gt; Nx . to_flat_list ( ) |&gt; Enum . filter ( &amp; ( feature [ 3 ] [ &amp;1 ] &gt;= 0 ) ) end ) for b &lt;- beg_index , e &lt;- end_index , b &lt;= e , e - b + 1 &lt; @max_ans do { b , e , Nx . to_number ( Nx . add ( beg_logits [ b ] , end_logits [ e ] ) ) } end |&gt; Enum . sort ( &amp; ( elem ( &amp;1 , 2 ) &gt;= elem ( &amp;2 , 2 ) ) ) |&gt; Enum . take ( predict_num ) # make answer text with score |&gt; Enum . map ( fn { b , e , score } -&gt; b = Nx . to_number ( feature [ 3 ] [ b ] ) e = Nx . to_number ( feature [ 3 ] [ e ] ) { Enum . slice ( context_map , b .. e ) |&gt; Enum . join ( &quot; &quot; ) , score } end ) end end Launch MBertQA . # TflInterp.stop(MBertQA) MBertQA . start_link ( [ ] ) Displays the properties of the MBertQA model. TflInterp . info ( MBertQA )","ref":"mbert_qa.html#2-defining-the-inference-module-mbertqa","title":"mobile Bert Q&A - 2.Defining the inference module: MBertQA","type":"extras"},{"doc":"MBertQA . setup ( ) context = &quot;&quot;&quot; Google LLC is an American multinational technology company that specializes in Internet-related services and products, which include online advertising technologies, search engine, cloud computing, software, and hardware. It is considered one of the Big Four technology companies, alongside Amazon, Apple, and Facebook. Google was founded in September 1998 by Larry Page and Sergey Brin while they were Ph.D. students at Stanford University in California. Together they own about 14 percent of its shares and control 56 percent of the stockholder voting power through supervoting stock. They incorporated Google as a California privately held company on September 4, 1998, in California. Google was then reincorporated in Delaware on October 22, 2002. An initial public offering (IPO) took place on August 19, 2004, and Google moved to its headquarters in Mountain View, California, nicknamed the Googleplex. In August 2015, Google announced plans to reorganize its various interests as a conglomerate called Alphabet Inc. Google is Alphabet&#39;s leading subsidiary and will continue to be the umbrella company for Alphabet&#39;s Internet interests. Sundar Pichai was appointed CEO of Google, replacing Larry Page who became the CEO of Alphabet. &quot;&quot;&quot; &quot;What is CEO of Google?&quot; |&gt; MBertQA . apply ( context , 3 ) |&gt; Enum . each ( fn { ans , score } -&gt; IO . puts ( &quot; \\n &gt;ANS: \\&quot; \#{ ans } \\&quot; , score: \#{ score } &quot; ) end )","ref":"mbert_qa.html#3-let-s-try-it","title":"mobile Bert Q&A - 3.Let's try it","type":"extras"},{"doc":"&amp;#9633;","ref":"mbert_qa.html#4-til","title":"mobile Bert Q&A - 4.TIL ;-)","type":"extras"},{"doc":"File . cd! ( __DIR__ ) # for windows JP System . shell ( &quot;chcp 65001&quot; ) Mix . install ( [ { :tfl_interp , path : &quot;..&quot; } , { :cimg , path : &quot;../../cimg_ex&quot; } , { :nx , &quot;~&gt; 0.4.0&quot; } , { :kino , &quot;~&gt; 0.7.0&quot; } ] )","ref":"movenet.html","title":"Pose Estimation: MoveNet","type":"extras"},{"doc":"Thanks a lot!!!","ref":"movenet.html#0-original-work","title":"Pose Estimation: MoveNet - 0.Original work","type":"extras"},{"doc":"","ref":"movenet.html#implementation-with-tflinterp-in-elixir","title":"Pose Estimation: MoveNet - Implementation with TflInterp in Elixir","type":"extras"},{"doc":"Model&lt;br&gt; yolov4_1_3_608_608_static.onnx Pre-processing&lt;br&gt; Resize the input image to the size {608,608}, normalize to {0.0,1.0} and transpose NCHW. Post-processing&lt;br&gt; Filtering Boxes(output[0]) and Scores(output[1]) with Multi-class Non Maximum Suppression. defmodule Movenet do @width 192 @height 192 alias TflInterp , as : NNInterp use NNInterp , model : &quot;./model/lite-model_movenet_singlepose_lightning_tflite_int8_4.tflite&quot; , inputs : [ u8 : { 1 , @height , @width , 3 } ] , outputs : [ f32 : { 1 , 1 , 17 , 3 } ] def apply ( img ) do # preprocess input0 = CImg . builder ( img ) |&gt; CImg . resize ( { @width , @height } , :ul , 0 ) |&gt; CImg . to_binary ( dtype : &quot;&lt;u1&quot; ) # prediction output0 = session ( ) |&gt; NNInterp . set_input_tensor ( 0 , input0 ) |&gt; NNInterp . invoke ( ) |&gt; NNInterp . get_output_tensor ( 0 ) |&gt; Nx . from_binary ( :f32 ) |&gt; Nx . reshape ( { 17 , 3 } ) # postprocess { img_width , img_height , _ , _ } = CImg . shape ( img ) { :ok , to_bones ( output0 , { img_width , img_height } ) } end @bones [ { 0 , 1 , { 0 , 255 , 0 } } , { 0 , 2 , { 0 , 255 , 0 } } , { 1 , 3 , { 0 , 255 , 0 } } , { 2 , 4 , { 0 , 255 , 0 } } , { 0 , 5 , { 0 , 255 , 0 } } , { 0 , 6 , { 0 , 255 , 0 } } , { 5 , 7 , { 0 , 255 , 0 } } , { 7 , 9 , { 0 , 255 , 0 } } , { 6 , 8 , { 0 , 255 , 0 } } , { 8 , 10 , { 0 , 255 , 0 } } , { 5 , 6 , { 0 , 255 , 0 } } , { 5 , 11 , { 0 , 255 , 0 } } , { 6 , 12 , { 0 , 255 , 0 } } , { 11 , 12 , { 0 , 255 , 0 } } , { 11 , 13 , { 0 , 255 , 0 } } , { 13 , 15 , { 0 , 255 , 0 } } , { 12 , 14 , { 0 , 255 , 0 } } , { 14 , 16 , { 0 , 255 , 0 } } ] def to_bones ( t , { w , h } , threshold \\\\ 0.11 ) do { scale_x , scale_y } = if w &gt; h , do : { 1.0 , w / h } , else : { h / w , 1.0 } Enum . flat_map ( @bones , fn { p1 , p2 , color } -&gt; [ y1 , x1 , score1 ] = Nx . to_flat_list ( t [ p1 ] ) [ y2 , x2 , score2 ] = Nx . to_flat_list ( t [ p2 ] ) if score1 &gt; threshold &amp;&amp; score2 &gt; threshold do [ { x1 * scale_x , y1 * scale_y , x2 * scale_x , y2 * scale_y , color } ] else [ ] end end ) end end Launch Movenet . # OnnxInterp.stop(Resnet18) Movenet . start_link ( [ ] ) Display the properties of the Movenet model. TflInterp . info ( Movenet )","ref":"movenet.html#1-defining-the-inference-module-movenet","title":"Pose Estimation: MoveNet - 1.Defining the inference module: MoveNet","type":"extras"},{"doc":"defmodule DemoMovenet do def run ( path ) when is_binary ( path ) do img = CImg . load ( path ) with { :ok , res } &lt;- Movenet . apply ( img ) do Enum . reduce ( res , CImg . builder ( img ) , &amp; draw_item ( &amp;1 , &amp;2 ) ) |&gt; CImg . save ( &quot;xxx.jpg&quot; ) end end defp draw_item ( { x1 , y1 , x2 , y2 , color } , canvas ) do CImg . draw_line ( canvas , x1 , y1 , x2 , y2 , color ) end end","ref":"movenet.html#2-defining-execution-module-demomovenet","title":"Pose Estimation: MoveNet - 2.Defining execution module DemoMovenet","type":"extras"},{"doc":"LiveYOLOv4 . run ( &quot;dog.jpg&quot; )","ref":"movenet.html#3-let-s-try-it","title":"Pose Estimation: MoveNet - 3.Let's try it","type":"extras"},{"doc":"&amp;#9633;","ref":"movenet.html#appendix","title":"Pose Estimation: MoveNet - Appendix","type":"extras"},{"doc":"File . cd! ( __DIR__ ) # for windows JP # System.shell(&quot;chcp 65001&quot;) Mix . install ( [ { :onnx_interp , &quot;~&gt; 0.1.8&quot; } , { :cimg , &quot;~&gt; 0.1.14&quot; } , { :postdnn , &quot;~&gt; 0.1.5&quot; } , { :kino , &quot;~&gt; 0.7.0&quot; } ] )","ref":"yolov4.html","title":"Object Detection: YOLOv4","type":"extras"},{"doc":"Pytorch-YOLOv4 https://github.com/Tianxiaomo/pytorch-YOLOv4 This note usee the pretraind model converted from above project ;-) Thanks a lot!!!","ref":"yolov4.html#0-original-work","title":"Object Detection: YOLOv4 - 0.Original work","type":"extras"},{"doc":"","ref":"yolov4.html#implementation-with-onnxinterp-in-elixir","title":"Object Detection: YOLOv4 - Implementation with OnnxInterp in Elixir","type":"extras"},{"doc":"Model&lt;br&gt; yolov4_1_3_608_608_static.onnx Pre-processing&lt;br&gt; Resize the input image to the size {608,608}, normalize to {0.0,1.0} and transpose NCHW. Post-processing&lt;br&gt; Filtering Boxes(output[0]) and Scores(output[1]) with Multi-class Non Maximum Suppression. defmodule YOLOv4 do @moduledoc &quot;&quot;&quot; Original work: Pytorch-YOLOv4 - https://github.com/Tianxiaomo/pytorch-YOLOv4 &quot;&quot;&quot; alias OnnxInterp , as : NNInterp use NNInterp , model : &quot;./model/yolov4_1_3_608_608_static.onnx&quot; , url : &quot;https://github.com/shoz-f/onnx_interp/releases/download/models/yolov4_1_3_608_608_static.onnx&quot; , inputs : [ f32 : { 1 , 3 , 608 , 608 } ] , outputs : [ f32 : { 1 , 22743 , 1 , 4 } , f32 : { 1 , 22743 , 80 } ] def apply ( img ) do # preprocess input0 = img |&gt; CImg . resize ( { 608 , 608 } ) |&gt; CImg . to_binary ( [ { :range , { 0.0 , 1.0 } } , :nchw ] ) # prediction outputs = session ( ) |&gt; NNInterp . set_input_tensor ( 0 , input0 ) |&gt; NNInterp . invoke ( ) # postprocess boxes = NNInterp . get_output_tensor ( outputs , 0 ) scores = NNInterp . get_output_tensor ( outputs , 1 ) PostDNN . non_max_suppression_multi_class ( { 22743 , 80 } , boxes , scores , boxrepr : :corner , label : &quot;./model/coco.label&quot; ) end end Launch YOLOv4 . # OnnxInterp.stop(Resnet18) YOLOv4 . start_link ( [ ] ) Display the properties of the YOLOv4 model. OnnxInterp . info ( YOLOv4 )","ref":"yolov4.html#1-defining-the-inference-module-yolov4","title":"Object Detection: YOLOv4 - 1.Defining the inference module: YOLOv4","type":"extras"},{"doc":"defmodule LiveYOLOv4 do @palette CImg.Util . rand_palette ( &quot;./model/coco.label&quot; ) def run ( path ) do img = CImg . load ( path ) with { :ok , res } &lt;- YOLOv4 . apply ( img ) do IO . inspect ( res ) Enum . reduce ( res , CImg . builder ( img ) , &amp; draw_item ( &amp;1 , &amp;2 ) ) |&gt; CImg . display_kino ( :jpeg ) end end defp draw_item ( { name , boxes } , canvas ) do color = @palette [ name ] Enum . reduce ( boxes , canvas , fn [ _score , x1 , y1 , x2 , y2 , _index ] , canvas -&gt; [ x1 , y1 , x2 , y2 ] = PostDNN . clamp ( [ x1 , y1 , x2 , y2 ] , { 0.0 , 1.0 } ) CImg . fill_rect ( canvas , x1 , y1 , x2 , y2 , color , 0.35 ) end ) end end","ref":"yolov4.html#2-defining-execution-module-liveyolov4","title":"Object Detection: YOLOv4 - 2.Defining execution module LiveYOLOv4","type":"extras"},{"doc":"LiveYOLOv4 . run ( &quot;dog.jpg&quot; )","ref":"yolov4.html#3-let-s-try-it","title":"Object Detection: YOLOv4 - 3.Let's try it","type":"extras"},{"doc":"&amp;#9633;","ref":"yolov4.html#appendix","title":"Object Detection: YOLOv4 - Appendix","type":"extras"}]